Index: LMDZ5/branches/testing/libf/dyn3dmem/vlspltgen_loc.F
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/vlspltgen_loc.F	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3dmem/vlspltgen_loc.F	(revision 2298)
@@ -27,5 +27,7 @@
       USE Write_Field_loc
       USE VAMPIR
-      USE infotrac, ONLY : nqtot
+      ! CRisi: on rajoute variables utiles d'infotrac  
+      USE infotrac, ONLY : nqtot,nqperes,nqdesc,nqfils,iqfils, 
+     &    ok_iso_verif
       USE vlspltgen_mod
       IMPLICIT NONE
@@ -64,5 +66,5 @@
       REAL ptarg,pdelarg,foeew,zdelta
       REAL tempe(ijb_u:ije_u)
-      INTEGER ijb,ije,iq
+      INTEGER ijb,ije,iq,iq2,ifils
       LOGICAL, SAVE :: firstcall=.TRUE.
 !$OMP THREADPRIVATE(firstcall)
@@ -150,17 +152,21 @@
       ije=ij_end
 
+      DO iq=1,nqtot
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)      
       DO l=1,llm
          DO ij=ijb,ije
-            mw(ij,l)=w(ij,l) * zzw
+            mw(ij,l,iq)=w(ij,l) * zzw
          ENDDO
       ENDDO
 c$OMP END DO NOWAIT
-
+      ENDDO
+
+      DO iq=1,nqtot  
 c$OMP MASTER
       DO ij=ijb,ije
-         mw(ij,llm+1)=0.
+         mw(ij,llm+1,iq)=0.
       ENDDO
 c$OMP END MASTER
+      ENDDO
 
 c      CALL SCOPY(ijp1llm,q,1,zq,1)
@@ -170,5 +176,5 @@
        ije=ij_end
 
-      DO iq=1,nqtot
+      DO iq=1,nqtot       
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
         DO l=1,llm
@@ -179,5 +185,5 @@
       ENDDO
 
-#ifdef DEBUG_IO    
+#ifdef DEBUG_IO     
        CALL WriteField_u('mu',mu)
        CALL WriteField_v('mv',mv)
@@ -186,11 +192,169 @@
 #endif
 
+      ! verif temporaire
+      ijb=ij_begin
+      ije=ij_end  
+      if (ok_iso_verif) then
+        call check_isotopes(zq,ijb,ije,'vlspltgen_loc 191')
+      endif !if (ok_iso_verif) then   
+
 c$OMP BARRIER           
-      DO iq=1,nqtot
-
+!      DO iq=1,nqtot
+      DO iq=1,nqperes ! CRisi: on ne boucle que sur les pères= ceux qui sont transportés directement par l'air
+       !write(*,*) 'vlspltgen 192: iq,iadv=',iq,iadv(iq)
+#ifdef DEBUG_IO    
+       CALL WriteField_u('zq',zq(:,:,iq))
+       CALL WriteField_u('zm',zm(:,:,iq)) 
+#endif
+        if(iadv(iq) == 0) then
+	
+	  cycle 
+	
+	else if (iadv(iq)==10) then
+
+#ifdef _ADV_HALO        
+! CRisi: on ajoute les nombres de fils et tableaux des fils
+! On suppose qu'on ne peut advecter les fils que par le schéma 10.  
+	  call vlx_loc(zq,pente_max,zm,mu,
+     &	             ij_begin,ij_begin+2*iip1-1,iq)
+          call vlx_loc(zq,pente_max,zm,mu,
+     &               ij_end-2*iip1+1,ij_end,iq)
+#else
+	  call vlx_loc(zq,pente_max,zm,mu,
+     &	             ij_begin,ij_end,iq)
+#endif
+
+c$OMP MASTER
+          call VTb(VTHallo)
+c$OMP END MASTER
+          call Register_Hallo_u(zq(:,:,iq),llm,2,2,2,2,MyRequest1)
+          call Register_Hallo_u(zm(:,:,iq),llm,1,1,1,1,MyRequest1)
+! CRisi
+          do ifils=1,nqdesc(iq)
+            iq2=iqfils(ifils,iq)
+            call Register_Hallo_u(zq(:,:,iq2),llm,2,2,2,2,MyRequest1)
+            call Register_Hallo_u(zm(:,:,iq2),llm,1,1,1,1,MyRequest1)
+          enddo
+
+c$OMP MASTER
+          call VTe(VTHallo)
+c$OMP END MASTER
+	else if (iadv(iq)==14) then
+
+#ifdef _ADV_HALO           
+          call vlxqs_loc(zq,pente_max,zm,mu,
+     &                   qsat,ij_begin,ij_begin+2*iip1-1,iq)
+          call vlxqs_loc(zq,pente_max,zm,mu,
+     &                   qsat,ij_end-2*iip1+1,ij_end,iq)
+#else
+          call vlxqs_loc(zq,pente_max,zm,mu,
+     &                   qsat,ij_begin,ij_end,iq)
+#endif
+
+c$OMP MASTER
+          call VTb(VTHallo)
+c$OMP END MASTER
+
+          call Register_Hallo_u(zq(:,:,iq),llm,2,2,2,2,MyRequest1)
+          call Register_Hallo_u(zm(:,:,iq),llm,1,1,1,1,MyRequest1)
+          do ifils=1,nqdesc(iq)
+            iq2=iqfils(ifils,iq)
+            call Register_Hallo_u(zq(:,:,iq2),llm,2,2,2,2,MyRequest1)
+            call Register_Hallo_u(zm(:,:,iq2),llm,1,1,1,1,MyRequest1)
+          enddo
+
+c$OMP MASTER
+          call VTe(VTHallo)
+c$OMP END MASTER 
+        else
+	
+	  stop 'vlspltgen_p : schema non parallelise'
+      
+        endif
+      
+      enddo !DO iq=1,nqperes
+      
+      
+c$OMP BARRIER      
+c$OMP MASTER      
+      call VTb(VTHallo)
+c$OMP END MASTER
+
+      call SendRequest(MyRequest1)
+
+c$OMP MASTER
+      call VTe(VTHallo)
+c$OMP END MASTER       
+c$OMP BARRIER
+
+      ! verif temporaire
+      ijb=ij_begin-2*iip1
+      ije=ij_end+2*iip1  
+      if (pole_nord) ijb=ij_begin
+      if (pole_sud)  ije=ij_end  
+      if (ok_iso_verif) then
+           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 280')
+      endif !if (ok_iso_verif) then
+
+      do iq=1,nqperes
+        !write(*,*) 'vlspltgen 279: iq=',iq
+
+        if(iadv(iq) == 0) then
+	
+	  cycle 
+	
+	else if (iadv(iq)==10) then
+
+#ifdef _ADV_HALLO
+          call vlx_loc(zq,pente_max,zm,mu,
+     &                 ij_begin+2*iip1,ij_end-2*iip1,iq)
+#endif        
+	else if (iadv(iq)==14) then
+#ifdef _ADV_HALLO
+          call vlxqs_loc(zq,pente_max,zm,mu,
+     &                    qsat,ij_begin+2*iip1,ij_end-2*iip1,iq)
+#endif    
+        else
+	
+	  stop 'vlspltgen_p : schema non parallelise'
+      
+        endif
+      
+      enddo
+c$OMP BARRIER      
+c$OMP MASTER
+      call VTb(VTHallo)
+c$OMP END MASTER
+
+!      call WaitRecvRequest(MyRequest1)
+!      call WaitSendRequest(MyRequest1)
+c$OMP BARRIER
+       call WaitRequest(MyRequest1)
+
+
+c$OMP MASTER
+      call VTe(VTHallo)
+c$OMP END MASTER
+c$OMP BARRIER
+
+      
+      if (ok_iso_verif) then
+           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 326')
+      endif !if (ok_iso_verif) then        
+      if (ok_iso_verif) then
+           ijb=ij_begin-2*iip1
+           ije=ij_end+2*iip1
+           if (pole_nord) ijb=ij_begin
+           if (pole_sud)  ije=ij_end
+           call check_isotopes(zq,ijb,ije,'vlspltgen_loc 336')
+      endif !if (ok_iso_verif) then  
+
+      do iq=1,nqperes
+       !write(*,*) 'vlspltgen 321: iq=',iq
 #ifdef DEBUG_IO    
        CALL WriteField_u('zq',zq(:,:,iq))
        CALL WriteField_u('zm',zm(:,:,iq))
 #endif
+
         if(iadv(iq) == 0) then
 	
@@ -198,47 +362,12 @@
 	
 	else if (iadv(iq)==10) then
-
-#ifdef _ADV_HALO        
-	  call vlx_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &	             ij_begin,ij_begin+2*iip1-1)
-          call vlx_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &               ij_end-2*iip1+1,ij_end)
-#else
-	  call vlx_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &	             ij_begin,ij_end)
-#endif
-
-c$OMP MASTER
-          call VTb(VTHallo)
-c$OMP END MASTER
-          call Register_Hallo_u(zq(:,:,iq),llm,2,2,2,2,MyRequest1)
-          call Register_Hallo_u(zm(:,:,iq),llm,1,1,1,1,MyRequest1)
-
-c$OMP MASTER
-          call VTe(VTHallo)
-c$OMP END MASTER
+        
+          call vly_loc(zq,pente_max,zm,mv,iq)
+  
 	else if (iadv(iq)==14) then
-
-#ifdef _ADV_HALO           
-          call vlxqs_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &                   qsat,ij_begin,ij_begin+2*iip1-1)
-          call vlxqs_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &                   qsat,ij_end-2*iip1+1,ij_end)
-#else
-
-          call vlxqs_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &                   qsat,ij_begin,ij_end)
-#endif
-
-c$OMP MASTER
-          call VTb(VTHallo)
-c$OMP END MASTER
-
-          call Register_Hallo_u(zq(:,:,iq),llm,2,2,2,2,MyRequest1)
-          call Register_Hallo_u(zm(:,:,iq),llm,1,1,1,1,MyRequest1)
-
-c$OMP MASTER
-          call VTe(VTHallo)
-c$OMP END MASTER 
+      
+          call vlyqs_loc(zq,pente_max,zm,mv,
+     &                   qsat,iq)
+ 
         else
 	
@@ -246,78 +375,92 @@
       
         endif
-      
-      enddo
-      
-      
-c$OMP BARRIER      
-c$OMP MASTER      
-      call VTb(VTHallo)
-c$OMP END MASTER
-
-      call SendRequest(MyRequest1)
-
-c$OMP MASTER
-      call VTe(VTHallo)
-c$OMP END MASTER       
-c$OMP BARRIER
-      do iq=1,nqtot
-
-        if(iadv(iq) == 0) then
-	
-	  cycle 
-	
-	else if (iadv(iq)==10) then
-
-#ifdef _ADV_HALLO
-          call vlx_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &                 ij_begin+2*iip1,ij_end-2*iip1)
-#endif        
-	else if (iadv(iq)==14) then
-#ifdef _ADV_HALLO
-          call vlxqs_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &                    qsat,ij_begin+2*iip1,ij_end-2*iip1)
-#endif    
-        else
-	
-	  stop 'vlspltgen_p : schema non parallelise'
-      
-        endif
-      
-      enddo
-c$OMP BARRIER      
-c$OMP MASTER
-      call VTb(VTHallo)
-c$OMP END MASTER
-
-!      call WaitRecvRequest(MyRequest1)
-!      call WaitSendRequest(MyRequest1)
-c$OMP BARRIER
-       call WaitRequest(MyRequest1)
-
-
-c$OMP MASTER
-      call VTe(VTHallo)
-c$OMP END MASTER
-c$OMP BARRIER
-
-
-      do iq=1,nqtot
+       
+       enddo
+
+      if (ok_iso_verif) then
+           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 357')
+      endif !if (ok_iso_verif) then
+
+      do iq=1,nqperes
+      !write(*,*) 'vlspltgen 349: iq=',iq
 #ifdef DEBUG_IO    
        CALL WriteField_u('zq',zq(:,:,iq))
        CALL WriteField_u('zm',zm(:,:,iq))
 #endif
+        if(iadv(iq) == 0) then 
+	  
+	  cycle 
+	
+	else if (iadv(iq)==10 .or. iadv(iq)==14 ) then
+
+c$OMP BARRIER        
+#ifdef _ADV_HALLO
+          call vlz_loc(zq,pente_max,zm,mw,
+     &               ij_begin,ij_begin+2*iip1-1,iq)
+          call vlz_loc(zq,pente_max,zm,mw,
+     &               ij_end-2*iip1+1,ij_end,iq)
+#else
+          call vlz_loc(zq,pente_max,zm,mw,
+     &               ij_begin,ij_end,iq)
+#endif
+c$OMP BARRIER
+
+c$OMP MASTER
+          call VTb(VTHallo)
+c$OMP END MASTER
+
+          call Register_Hallo_u(zq(:,:,iq),llm,2,2,2,2,MyRequest2)
+          call Register_Hallo_u(zm(:,:,iq),llm,1,1,1,1,MyRequest2)
+          ! CRisi
+          do ifils=1,nqdesc(iq)
+            iq2=iqfils(ifils,iq)
+            call Register_Hallo_u(zq(:,:,iq2),llm,2,2,2,2,MyRequest2)
+            call Register_Hallo_u(zm(:,:,iq2),llm,1,1,1,1,MyRequest2)
+          enddo      
+c$OMP MASTER
+          call VTe(VTHallo)
+c$OMP END MASTER	
+c$OMP BARRIER
+        else
+	
+	  stop 'vlspltgen_p : schema non parallelise'
+      
+        endif
+      
+      enddo
+c$OMP BARRIER      
+
+c$OMP MASTER        
+      call VTb(VTHallo)
+c$OMP END MASTER
+
+      call SendRequest(MyRequest2)
+
+c$OMP MASTER
+      call VTe(VTHallo)
+c$OMP END MASTER	
+
+
+      if (ok_iso_verif) then
+           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 429')
+      endif !if (ok_iso_verif) then 
+
+c$OMP BARRIER
+      do iq=1,nqperes
+      !write(*,*) 'vlspltgen 409: iq=',iq
+
         if(iadv(iq) == 0) then
-	
+	  
 	  cycle 
 	
-	else if (iadv(iq)==10) then
-        
-          call vly_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mv)
-  
-	else if (iadv(iq)==14) then
-      
-          call vlyqs_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mv,
-     &                   qsat)
- 
+	else if (iadv(iq)==10 .or. iadv(iq)==14 ) then
+c$OMP BARRIER        
+
+#ifdef _ADV_HALLO
+          call vlz_loc(zq,pente_max,zm,mw,
+     &               ij_begin+2*iip1,ij_end-2*iip1,iq)
+#endif
+
+c$OMP BARRIER        
         else
 	
@@ -325,162 +468,102 @@
       
         endif
-       
-       enddo
-
-
-      do iq=1,nqtot
+      
+      enddo
+      !write(*,*) 'vlspltgen_loc 476'
+
+c$OMP BARRIER
+      !write(*,*) 'vlspltgen_loc 477'
+c$OMP MASTER
+      call VTb(VTHallo)
+c$OMP END MASTER
+
+!      call WaitRecvRequest(MyRequest2)
+!      call WaitSendRequest(MyRequest2)
+c$OMP BARRIER
+       CALL WaitRequest(MyRequest2)
+
+c$OMP MASTER
+      call VTe(VTHallo)
+c$OMP END MASTER
+c$OMP BARRIER
+
+
+      !write(*,*) 'vlspltgen_loc 494'
+      if (ok_iso_verif) then
+           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 461')
+      endif !if (ok_iso_verif) then
+
+      do iq=1,nqperes
+      !write(*,*) 'vlspltgen 449: iq=',iq
 #ifdef DEBUG_IO    
        CALL WriteField_u('zq',zq(:,:,iq))
        CALL WriteField_u('zm',zm(:,:,iq))
 #endif
+        if(iadv(iq) == 0) then
+	
+	  cycle 
+	
+	else if (iadv(iq)==10) then
+        
+          call vly_loc(zq,pente_max,zm,mv,iq)
+  
+	else if (iadv(iq)==14) then
+      
+          call vlyqs_loc(zq,pente_max,zm,mv,
+     &                   qsat,iq)
+ 
+        else
+	
+	  stop 'vlspltgen_p : schema non parallelise'
+      
+        endif
+       
+       enddo !do iq=1,nqperes
+
+      if (ok_iso_verif) then
+           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 493')
+      endif !if (ok_iso_verif) then
+
+      do iq=1,nqperes
+      !write(*,*) 'vlspltgen 477: iq=',iq
+#ifdef DEBUG_IO    
+       CALL WriteField_u('zq',zq(:,:,iq))
+       CALL WriteField_u('zm',zm(:,:,iq))
+#endif
         if(iadv(iq) == 0) then 
 	  
 	  cycle 
 	
-	else if (iadv(iq)==10 .or. iadv(iq)==14 ) then
-
-c$OMP BARRIER        
-#ifdef _ADV_HALLO
-          call vlz_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mw,
-     &               ij_begin,ij_begin+2*iip1-1)
-          call vlz_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mw,
-     &               ij_end-2*iip1+1,ij_end)
-#else
-          call vlz_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mw,
-     &               ij_begin,ij_end)
-#endif
-c$OMP BARRIER
-
-c$OMP MASTER
-          call VTb(VTHallo)
-c$OMP END MASTER
-
-          call Register_Hallo_u(zq(:,:,iq),llm,2,2,2,2,MyRequest2)
-          call Register_Hallo_u(zm(:,:,iq),llm,1,1,1,1,MyRequest2)
-
-c$OMP MASTER
-          call VTe(VTHallo)
-c$OMP END MASTER	
-c$OMP BARRIER
-        else
-	
-	  stop 'vlspltgen_p : schema non parallelise'
-      
-        endif
-      
-      enddo
-c$OMP BARRIER      
-
-c$OMP MASTER        
-      call VTb(VTHallo)
-c$OMP END MASTER
-
-      call SendRequest(MyRequest2)
-
-c$OMP MASTER
-      call VTe(VTHallo)
-c$OMP END MASTER	
-
-c$OMP BARRIER
-      do iq=1,nqtot
-
-        if(iadv(iq) == 0) then
-	  
-	  cycle 
-	
-	else if (iadv(iq)==10 .or. iadv(iq)==14 ) then
-c$OMP BARRIER        
-
-#ifdef _ADV_HALLO
-          call vlz_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mw,
-     &               ij_begin+2*iip1,ij_end-2*iip1)
-#endif
-
-c$OMP BARRIER        
-        else
-	
-	  stop 'vlspltgen_p : schema non parallelise'
-      
-        endif
-      
-      enddo
-
-c$OMP BARRIER
-c$OMP MASTER
-      call VTb(VTHallo)
-c$OMP END MASTER
-
-!      call WaitRecvRequest(MyRequest2)
-!      call WaitSendRequest(MyRequest2)
-c$OMP BARRIER
-       CALL WaitRequest(MyRequest2)
-
-c$OMP MASTER
-      call VTe(VTHallo)
-c$OMP END MASTER
-c$OMP BARRIER
-
-
-      do iq=1,nqtot
-#ifdef DEBUG_IO    
-       CALL WriteField_u('zq',zq(:,:,iq))
-       CALL WriteField_u('zm',zm(:,:,iq))
-#endif
-        if(iadv(iq) == 0) then
-	
-	  cycle 
-	
 	else if (iadv(iq)==10) then
         
-          call vly_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mv)
+          call vlx_loc(zq,pente_max,zm,mu,
+     &               ij_begin,ij_end,iq)
   
 	else if (iadv(iq)==14) then
       
-          call vlyqs_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mv,
-     &                   qsat)
+          call vlxqs_loc(zq,pente_max,zm,mu,
+     &                 qsat, ij_begin,ij_end,iq)
  
         else
 	
-	  stop 'vlspltgen_p : schema non parallelise'
+          stop 'vlspltgen_p : schema non parallelise'
       
         endif
        
-       enddo
-
-
-      do iq=1,nqtot
-#ifdef DEBUG_IO    
-       CALL WriteField_u('zq',zq(:,:,iq))
-       CALL WriteField_u('zm',zm(:,:,iq))
-#endif
-        if(iadv(iq) == 0) then 
-	  
-	  cycle 
-	
-	else if (iadv(iq)==10) then
-        
-          call vlx_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &               ij_begin,ij_end)
-  
-	else if (iadv(iq)==14) then
-      
-          call vlxqs_loc(zq(ijb_u,1,iq),pente_max,zm(ijb_u,1,iq),mu,
-     &                 qsat, ij_begin,ij_end)
- 
-        else
-	
-          stop 'vlspltgen_p : schema non parallelise'
-      
-        endif
-       
-       enddo
-
+       enddo !do iq=1,nqperes
+
+      !write(*,*) 'vlspltgen 550: apres derniere serie de call vlx'
+      if (ok_iso_verif) then
+           call check_isotopes(zq,ij_begin,ij_end,'vlspltgen_loc 521')
+      endif !if (ok_iso_verif) then
      
       ijb=ij_begin
       ije=ij_end
+      !write(*,*) 'vlspltgen_loc 557'
 c$OMP BARRIER      
 
-
+      !write(*,*) 'vlspltgen_loc 559'  
       DO iq=1,nqtot
+       !write(*,*) 'vlspltgen_loc 561, iq=',iq  
 #ifdef DEBUG_IO    
        CALL WriteField_u('zq',zq(:,:,iq))
@@ -495,5 +578,6 @@
            ENDDO
         ENDDO
-c$OMP END DO NOWAIT          
+c$OMP END DO NOWAIT    
+      !write(*,*) 'vlspltgen_loc 575'      
 
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)
@@ -504,8 +588,11 @@
         ENDDO
 c$OMP END DO NOWAIT  
-
-      ENDDO
+      !write(*,*) 'vlspltgen_loc 583'  
+      ENDDO !DO iq=1,nqtot
         
-      
+      if (ok_iso_verif) then
+           call check_isotopes(q,ij_begin,ij_end,'vlspltgen_loc 557')
+      endif !if (ok_iso_verif) then
+
 c$OMP BARRIER
 
@@ -516,4 +603,5 @@
 cc$OMP BARRIER
 
+      !write(*,*) 'vlspltgen 597: sortie'  
       RETURN
       END
Index: LMDZ5/branches/testing/libf/dyn3dmem/vlspltgen_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/dyn3dmem/vlspltgen_mod.F90	(revision 2274)
+++ LMDZ5/branches/testing/libf/dyn3dmem/vlspltgen_mod.F90	(revision 2298)
@@ -2,7 +2,7 @@
 
   REAL,POINTER,SAVE :: qsat(:,:)
-  REAL,POINTER,SAVE :: mu(:,:)
+  REAL,POINTER,SAVE :: mu(:,:) ! CRisi: on ajoute une dimension
   REAL,POINTER,SAVE :: mv(:,:)
-  REAL,POINTER,SAVE :: mw(:,:)
+  REAL,POINTER,SAVE :: mw(:,:,:)
   REAL,POINTER,SAVE :: zm(:,:,:)
   REAL,POINTER,SAVE :: zq(:,:,:)
@@ -25,5 +25,5 @@
     CALL allocate_u(mu,llm,d)
     CALL allocate_v(mv,llm,d)
-    CALL allocate_u(mw,llm+1,d)
+    CALL allocate_u(mw,llm+1,nqtot,d)
     CALL allocate_u(zm,llm,nqtot,d)
     CALL allocate_u(zq,llm,nqtot,d)
